
                   IL PROBLEMA DEI CAPPELLI caso 1

Un gruppo di amici si reca ad una festa dove una disordinata guardarobiera
prende in consegna i loro cappelli; ma nella confusione mescola i cartellini
e quando gli amici si ripresentano per ritirare i cappelli li consegna alla
rinfusa.

QUAL E` LA PROBABILITA` CHE TUTTI RITORNINO IN POSSESSO DEL LORO CAPPELLO ?


RISOLUZIONE:

La probabilita` che chi si ripresenta per primo ritorni in possesso del pro-
prio cappello e` 1/n; la probabilita` di chi si presenta per secondo e` 1/n-1;
per terzo 1/(n-2); per quarto 1/(n-3) eccetera

Quindi     P (tutti ritornano in possesso del loro cappello) =

                  1    1     1    1       1     1     1
            =    -- * --- * ---* ---* ..* -- * -- =  ---
                  n   n-1   n-2  n-3      2     1     n!

Il problema si puo` risolvere mediante simulazione:

Si prende una scatola e vi si pongono tante lettere diverse quante sono
gli amici che si recano alla festa; si mescolano, si estraggono simulando
cosi` l'ordine di ingresso e si memorizzano; si inzia poi una serie di prove
consistenti nell'estrazione delle lettere dalla scatola e controllando di vol-
ta in volta se vi sia coincidenza con l'ordine con cui le lettere sono state
estratte; se vi e` una totale coincidenza allora diciamo che vi e` stato un
successo.
  Alla fine il rapporto tra il numero dei successi e quello degli esperimenti
  puo` permettere una valutazione in senso frequentista della probabilita'
  richiesta.














