               PIANO NAZIONALE PER L'INTRODUZIONE
                  DELL'INFORMATICA NELLE SCUOLE
                      SECONDARIE SUPERIORI
                      --------------------
                          POLO DI UDINE
                         A.S 198  '89
                      --------------------
           L.Bernetti G.Filippozzi F.Petrossi S.Riggio


                             U.D. 15

                   RIDUZION DELLA COMPLESSITA :
                         L RICORSIVITA'

                        ----------------           
           
.pa
      UD1  RIDUZION DELL COMPLESSITA  L RICORSIVITA'

CODICE:
UDR915

POLO:
UDINE

AUTORI:
L.Bernetti G.Filippozzi F.Petrossi S.Riggio

AREA:
Informatica disciplinare

TEMA:
Disciplinar matematica element d logic  informatica;
linguagg d programmazione Logo

OBIETTIVI:
 riconosciment dell caratteristich propri a un definizion 
ricorsiv d procedura
 rappresentazion grafic de funzionament d u algoritm 
ricorsivo
 valutazion dell portat dell ricorsion i ambit matematic 
e i ambit piu vasti

CONTENUTI:
 i principi d induzion completa
 funzion definit ricorsivamente
 cas terminal  riduzion dell complessita'
 esemo d definizion ricorsiv i vari ambiti

FAS  TEMPI
Presentazione        h
Laboratorio          h

MATERIALI
 programm i Pasca ( i Logo)
 sched d eserciz i Pascal

BIBLIOGRAFIA
 G Glaese "L matematic modern pe ch dev insegnarla" 
Feltrinell 
 F.Petross (articol s COMPUSCUOL relativ a Logo)
.pa
DESCRIZIONE:
Gl assiom d Pean su numer natural e i particolar i 
principi d induzion complet portan all possibilita teoric 
d definir funzion i mod ricorsivo "pe ipsum" Divers 
algoritm d calcol molt usat posson esser pensat i mod 
ricorsivo.
L'analis d procedur ch chiaman se stess port  chiarir 
l necessita d u "cas terminale  d u process d gradual 
"riduzion dell complessita' ch port a ess i molt 
definizion ricorsive.
I meccanism d ricorsion e associat all struttur dat d 
"pila".
Vengon dat divers esemp d definizion ricorsive.


.pa
.po0
           Introduzione           

           Parlando di  ricorsione (1),  se si  proviene da un
        ambiente matematico,  si e'  portati ad associare tale
        termine all'induzione  e ad  andare col  pensiero alla
        definizione assiomatica,  data  da  Peano,  di  numero
        naturale (2):
           
           1) 0 e' un numero
           2) il successivo di un numero e' un numero
           3) se  due numeri  hanno  successivi  uguali,  sono
        uguali
           4) 0 non e' il successivo di alcun numero
           5) se  una proprieta'  e' vera  per 0 e se, ammessa
        per n,  essa e'  pure vera  per il  successivo  di  n,
        allora la proprieta' e' vera per ogni numero  ;
           
           la proprieta' 5) e' indicata pure come principio di
        induzione completa.
           
           Per dimostrare  che una  proprieta' e'  valida  per
        ogni  naturale,   seguendo  l'assioma   5)  e'  quindi
        possibile dimostrarne  la validita'  per lo zero e far
        derivare la dimostrazione per il successivo di n dalla
        validita' di essa per n.
           
           Da tale  principio,  attraverso  una  dimostrazione
        piuttosto delicata  (3),  e'  possibile  enunciare  un
        teorema che  permette per  le funzioni una definizione
        per ricorrenza:
           
                  esiste un'unica funzione per cui si abbia
                  f(0) = a    e   f( S(x) ) = g( f(x) ) ,
                  con f: N* -> E     e     g: E -> E.
                       S(x):= il successivo di x
           
           Tale teorema  e' -  a dire  il vero - il fondamento
        dell'aritmetica, sempre nell'ambito di una definizione
        assiomatica di  numero naturale;  attraverso  esso  e'
        possibile definire l'addizione, la moltiplicazione, la
        disuguaglianza ecc.. Per l'addizione bastera' definire
        per ogni naturale a una funzione tale che:
           
           fa( 0 ) = a                  ovvero a + 0 = a

           fa( S(x) ) = S( fa(x) )    a + (x + 1)= (a + x) + 1.
.pa
           quindi ad esempio:
           
           4 + 3 = 4 + S(2) =
                 = S(4 + 2) = S(4 + S(1)) =
                           S(S(4 + 1)) = S(S(4 + S(0)))=
                                    S(S(S(4 +0)))=S(S(S(4)))
           
        "detto" 7
           
           Il ragionamento per ricorrenza va al di la' di casi
        cosi' strettamente  legati  ai  numeri  naturali  (pur
        avendo in  essi  il  fondamento).  In  generale  nella
        definizione di  una funzione  - o  in  genere  di  una
        procedura - per ricorrenza bisogna individuare:
           
           - un caso terminale
          
           - un procedimento che riduca il caso piu' complesso
        ad uno  piu' semplice,  ovvero tale  da avvicinarsi al
        caso terminale (4).
           
           
           Con minore  volonta' di  teorizzazione vale la pena
        pensare che  comunque molti  algoritmi molto noti sono
        spesso  pensati  da  noi  stessi  come  ricorsivi.  Un
        esempio puo' essere il procedimento di moltiplicazione
        in colonna di due numeri:
           
                       1 2 *
                       2 7 =
                    --------
                       8 4
                     2 4 0
                    --------
                     3 2 4
           
           la  definizione  del  procedimento  di  solito  non
        indica   il   numero   di   cifre   interessate   alla
        moltiplicazione, indica solo che
           -   c'e'    un   caso   terminale,   quello   della
        moltiplicazione di  un numero  per un altro costituito
        da una sola cifra
           - se  il secondo  numero ha  piu' di  una cifra  e'
        possibile ridurre  la moltiplicazione  ad una somma di
        prodotti del  primo numero per le singole cifre da cui
        e' costituito il secondo.

.pa
           Una possibile definizione in linguaggio di progetto
        potrebbe essere:
           
           prodotto in colonna :
           
           prodotto(a,b)
             se b < 10 riporta a * b
               altrimenti riporta
                a * ultima_cifra(b) +
                 prodotto(a,restanti_cifre(b)) * 10
           
           
           Si puo'  notare  che  la  definizione  di  prodotto
        richiama se'  stessa, ma  con un grado di complessita'
        ridotto, ovvero  piu' vicino (in termini del numero di
        cifre del  secondo termine  della moltiplicazione)  al
        caso terminale  "prodotto per  un numero con una cifra
        sola".
----------------------------
        v Fil POTENZA.PAS           
.pa           
           ---------------------------------------------------
           Per esercizio  si provino  ad analizzare ora alcune
        procedure che richiamano se' stesse:
           
           procedura passeggia_1
             avanti un passo
             passeggia_1
           
           procedura passeggia_2(numero)
             avanti un numero di passi
             passeggia_2(2 * numero)
           
           procedura passeggia_3(numero)
             avanti un numero di passi
             passeggia_3(numero / 2)
           
           procedura passeggia_4(numero)
             se in numero e' minore di 1 fermati
             altrimenti avanti un numero di passi
                        passeggia_4(numero/2)
           
           
           Tra queste  procedure  si  individuino  quelle  che
        corrispondono  ad   una  "definizione   ricorsiva   di
        procedura" come sopra illustrato
           ---------------------------------------------------
.pa           
           Il meccanismo della ricorsione
        
           Per esemplificare  il funzionamento  del meccanismo
        di  attuazione   di  una   definizione  ricorsiva   si
        consideri la seguente procedura


                  Procedura passeggiata(n)
                       se n <= 1 stop
                       altrimenti avanti(n)
                                  passeggiata(n/2)
                                  indietro(n)
           
           che   qui    verra'    esemplificata    nel    caso
        passeggiata(8) :
           
           |------->|--->|->|
           |<-------|<---|<-|
           
           +-- passeggiata(8) --+
           |                    |
           | avanti(8)          |
           | +-- passeggiata(4) --+
           | |                    |
           | | avanti(4)          |
           | | +-- passeggiata(2) --+
           | | |                    |
           | | | avanti(2)          |
           | | | +-- passeggiata(1) --+
           | | | |                    |
           | | | | fermo              |
           | | | +--------------------+
           | | | indietro(2)        |
           | | +--------------------+
           | | indietro(4)        |
           | +--------------------+
           | indietro(8)        |
           +--------------------+
           
           
           Questo meccanismo  ricorda, come  organizzazione  e
        reperimento dei dati (nel nostro caso delle azioni) la
        struttura di pila.
           Un  diverso   modo  di   visualizzare   la   stessa
        situazione e' il seguente:
           
   passeggiata(8): +- passeggiata(4): +- passeggiata(2): +- passeggiata(1):
   avanti(8)       |  avanti(4)       |  avanti(2)       |  fermo
   passeggiata(4)--+  passeggiata(2)--+  passeggiata(1)--+
   indietro(8)        indietro(4)        indietro(2)
.pa
        
           Dall'analisi   di    tale    meccanismo    possiamo
        riconoscere  l'esistenza   nella  procedura   di   due
        momenti:
           
           CONDIZIONE TERMINALE:
           
           Passeggiata(x) ,  per x <= 1 , consiste nel non far
        nulla
           
           RIDUZIONE DELLA COMPLESSITA`:
           
           Passeggiata(x) ,  per x > 1 , consiste nel compiere
        azioni di  cui  alcune  portano  verso  la  condizione
        terminale .
           
           
           Esempi di definizioni ricorsive
           
           I)
           MODELLI FISICI E RICORSIONE:
           
           si consideri il moto rettilineo uniforme:
                  s0 = 10 m
                  s(n+1)  = sn  + vn  * t       con vn = 2 m/s per
        ogni n
                                          e t = 1 s
           
           il modello puo` esser letto partendo da s0
           10 --> 12 --> 14 --> ...
           
           o partendo da sn (ad esempio s2)
           
           +-- s2 ---
           |   +-- s1 ---
           |   |   +-- s0 ---
           |   |   |      10
           |   |   +---------
           |   |10 + 2*1
           |   +---------
           | 12 + 2*1
           +---------
           14 (risultato)
           
.pa           
           II)
           FATTORIALE
           
           condizione terminale:
           
           fattoriale(0) := 1
           
           avvicinamento:
           
           fattoriale(n) := n * fattoriale(n-1)
           
           
           esiste anche una formulazione iterativa, anziche` ricorsiva:
           
             i:=n
             fattoriale := 1
             mentre i <> 0
                   fattoriale := fattoriale * i
                   i := i - 1
           
           III)
           PROCEDURE GRAFICHE
           
           (Un esempio in Logo)
             PER SPIR :PASSO :ANGOLO
                  ....   viene omessa  la condizione terminale
        
                  AVANTI :PASSO
                  DESTRA :ANGOLO
                  SPIR (:PASSO + 1) :ANGOLO
             FINE
           
           CURVA DI KOCH
           
           Procedura LATO(dimensione,livello)
             se livello = 0 allora avanti dimensione
             altrimenti
                  LATO(dimensione/3, livello-1)
                  sinistra 60
                  LATO(dimensione/3, livello-1)
                  destra 120
                  LATO(dimensione/3, livello-1)
                  sinistra 60
                  LATO(dimensione/3, livello-1)
           
           la curva  ottenuta per  livello ->  e' continua ma
        non derivabile in alcun punto.

--------------------
        v Fil KOCH.PAS           
.pa           
	Koch (schizzo di massima)

	livello 0

	0                                    d
	-------------------------------------->
           
           
                          /120^
	livello 1        /\
                        /  \
                       /    \
                      /      \
             d/3     / 60^    \
	------------/---       \------------- 
                                \60^
           
                         /\
                    ----/  \----
         d/3        \          /
         ---         \        /
          3  /\      /        \      /\
	----/  \----/          \----/  \----
           
           

           IV)
           LA TECNICA DI DERIVAZIONE
           
           Procedura DERIVATA(espressione)
             .. casi terminali ...
             ...
             se    l'operando     e'    "*"     allora     fai
                DERIVA_PRODOTTO(espressione)
             ...
           
           
           Procedura DERIVA_PRODOTTO(espressione)
             riporta una lista composta di tre termini:
                  la  lista
                        DERIVATA(operando_destro(espressione))
                        simbolo "*"
                        operando_sinistro(espressione)
                  il simbolo "+"
                  la lista
                        operando_sinistro(espressione)
                        simbolo "*"
                        DERIVATA(operando_destro(espressione))
           
           
           In tale  caso la  procedura DERIVATA  chiama quella
        DERIVA_PRODOTTO e  viceversa:  in  questo  scambio  di
        ruoli  l'importante  e'  che  si  giunga  a  dei  casi
        terminali, ovvero  a delle  funzioni di  cui si sappia
        calcolare immediatamente la derivata.
           
           Quindi:
           
           D[ 3 * (a * x) ] =
                  D[3] * (a * x)  +  D[ a * x] =
                  = ....
           
           
	 NOTE           
        1 O ricorrenza, o ricorsivita' (per non parlare di recursione od
        altro): la terminologia e' varia e dipende dall'ambiente
        (matematico, informatico, modellistico) di provenienza
        dell'utilizzatore. Il significato e' lo stesso.

        2 La  formulazione degli  assiomi viene  effettuata  in  modo
        diverso dai vari autori, eccone una alternativa:
           0) N* e' un insieme
           1)  S  e'  un'applicazione  iniettiva  di  N*  in  N*  (detta
              successivo)
           2) 1 appartiene ad N*
           3) 1 non e' il successivo di nessun elemento di N*
           4) Ogni parte di A che soddisfa alle due proprieta' seguenti:
                I) 1 appartiene ad A 
               II) se  S(A) e' sottoinsieme di A , e' uguale ad N*.

       3 Si veda - con una diversa simbologia - G. Glaeser "La
        matematica moderna per chi deve insegnarla", Feltrinelli (pag
        131)
       
       4 Si scusi una terminologia euristica, qui "distante" non ha una
        denotazione metrica, indica un giungere al caso terminale in un
        numero finito di passi.

