/* Dr. Furio Petrossi - Udine */
 
?-op(9,yfx,^).
 
svil(X,X,[]) :- atomic(X),!.
 
svil(X + Y , A + B,R) :- svil(X , A,N),svil(Y , B,M),append(N,M,R).
svil(X * Y , A * B,R) :- svil(X , A,N), svil(Y , B,M),append(N,M,R).
svil(X ^ 2 , A ^ 2,N) :- svil(X , A,N).
 
svil(X^N^M, X^R,[ potenza_di_potenza] ) :-integer(N),integer(M),R is N*M.
svil(X + 0 , X,[neutro_zero]).
svil(X * Y, R ,[calcolo_prodotto]) :- integer(X),integer(Y),R is X*Y.
svil(X^2,R,[calcolo_quadrato]) :-integer(X),R is X*X.
svil(X * (Y * Z),X * Y * Z,[assoc_prodotto]).
 
svil((X*Y)^2,X^2*Y^2,[potenza_di_prodotto]).
svil( (X + Y)^2 , X^2 + 2*X*Y + Y^2,[quadrato_binomio] ).
svil( X * (Y + Z) , X*Y + X*Z,[distr_destra] ).
svil( (X + Y) * Z , X*Z + Y*Z,[distr_sinistra]).
svil( X  * W, W * X,[riassestamento]):-integer(W).
 
 
sviluppa(X):- svil( X , R,N),not X = R,!, nl,write('--- '),write(N),nl, write(R), sviluppa(R).
