.pl66
               PIANO NAZIONALE PER L'INTRODUZIONE
                  DELL'INFORMATICA NELLE SCUOLE
                      SECONDARIE SUPERIORI
                      --------------------
                          POLO DI UDINE
                         A.S 198  '89
                      --------------------
           L.Bernetti G.Filippozzi F.Petrossi S.Riggio


                             U.D. 3

                        LA SCOMPOSIZIONE
                        IN SOTTOPROBLEMI

                      (Analisi Top - Down)

                        ----------------
.pa
               UD SCOMPOSIZION I SOTTOPROBLEMI

CODICE:
UDR904

POLO:
UDINE

AUTORI:
L.Bernetti G.Filippozzi F.Petrossi S.Riggio

AREA:
Informatica

TEMA:
Situazion problematiche

OBIETTIVI
- determinare la relazione esistente tra sottoproblemi in un caso
di u disegno "modulare"
- conoscere il significato dei termini Top-Down e Bottom-Up
- derivare da un programma scritto in linguaggio di progetto la
relazione gerarchica tra i sottoprogrammi
- conoscere il concetto di primitiva
- conoscere le modalita' di comunicazione ad un esecutore

CONTENUTI
- Entrata nell'ambiente DrLogo
- Alcune primitive del DrLogo 
-Procedure con parametri, uso di alcune procedure del programma
   PANORAMA considerate separatamente
- Analisi della relazione tra le procedure
- Analisi della gerarchia tra procedure
- La scomposizione Top-Down
- La chiamata ad un sottoprogramma


FASI E TEMPI:
Lavor d gruppo           3 min
Discussion i aula       h

MATERIALI:
- scheda con la proposta di lavoro
- copia del DrLogo e del file PANORAMA
- copia del disegno
- schede informative

BIBLIOGRAFIA:
- U.D. 2 CILE (1986-87)

.pa
DESCRIZIONE:
Dop ave analizzat l piu semplic primitiv LOG s osserv 
l'esecuzion de programm "Panorama" ch disegn un schizz d 
paesaggi co element modulari  s sperimentan l singol 
procedur ch l compongono Sull bas dell version i 
linguaggi d progett de programm vien ricostruit l 
relazion esistent tr l divers procedure S ipotizz 
induttivament l metodologi to-dow ch da problem puo ave 
portat all operazion elementar ch permetton d risolverlo.
S analizz i meccanism d chiamat  sottoprogramma.
S analizzan vantagg  svantagg dell scomposizion To-Dow 
nell didattic (l'esempi dell geometri analitica)
.pa
.HEP.N.I POLO DI UDINE
.HEU.D. 3
.HESK 01
.FO<PAG>
NOTE OPERATIVE

Inserire nel Drive A (quello a sinistra) il DISCO PROGRAMMI
Inserire nel Drive B (a destra) il DISCO DI LAVORO
Accendere il computer e il monitor
Alla comparsa di  " A> " scrivere
logo
Alla comparsa del punto interrogativo scrivere
ASDISCO "B: seguito da Invio
ed in seguito
RECUPERA "PANORAMA seguito da Invio

Per eseguire il programma principale scrivere
PANORAMA    e Invio

Per vedere il listato di tutto il programma:
EDTUTTO_IN      Invio
utilizzare i tasti - freccia
premere F2 per smettere l'analisi


.pa
                        AREA INFORMATICA
                LA SCOMPOSIZIONE IN SOTTOPROBLEMI
                      ( Analisi Top-Down )

PROBLEMA 1

	Si osservi l'esecuzione sia del programma PANORAMA che dei
singoli sottoprogrammi che lo compongono e si prepari un'ipotesi
interpretativa, da proporre al gruppo relativa a:

	1) La relazione esistente tra i sottoprogrammi
	   ovvero il collegamento tra essi esistente

	2) La gerarchia tra sottoprogrammi
	   ovvero i diversi strati o livelli in cui possono
	   essere collocati i singoli sottoprogrammi .



PROBLEMA 2

	Ci si soffermi sull'aspetto formale della scrittura in
linguaggio progetto e si individuino le diverse classi in cui le
parole che in esso compaiono possono messe.
	Si analizzi il ruolo di queste classi nel momento della
comunicazione di un programma ad un esecutore.
	Si analizzino i diversi ruoli di
	- linguaggio di progetto
	- schematizzazione grafica
	- linguaggio di programmazione

.pa
LE PRIMITIVE DEL DR.LOGO

avanti n    o    a n
	produce l'avanzamento dell'esecutore di n unita'

destra alfa
sinistra alfa
	producono la rotazione di alfa gradi in senso orario o
antiorario

giu   {penna_giu nel linguaggio di progetto}
su    {penna_su nel linguaggio di progetto}
	sollevano o abbassano una immaginaria penna in modo da
lasciare una traccia o meno durante l'avanzamento dell'esecutore

mostarta {appari} 
	 mostra un'immagine dell'esecutore sullo schermo
nastarta {scompari}
	nasconde l'esecutore

tana  {centro}
	pone l'esecutore al centro dello schermo
pulisci
	cancella lo schermo senza spostare l'esecutore



ripeti n [ serie di istruzioni ]
	ripete n volte la serie di istruzioni scritta tra parentesi
quadre.
	Nel linguaggio di progetto la struttura e' resa con

	ripeti n volte
	inizio
	  serie di istruzioni
	fine
  

per    {programma o sottoprogramma}
	inizio della descrizione della procedura
fine
	fine della descrizione

:   - due punti -
	in Logo indica il valore della variabile indicata dal nome
che segue . Nel linguaggio di procetto viene indicato
direttamente il nome, senza farlo precedere da questo simbolo.

operazioni matematiche:  + - * /  COS 
.pa
altre primitive

assegna "nome valore
	(esempio ASSEGNA "A 32 oppure ASSEGNA "A "ZIO)
	corrisponde a:     nome <-- valore

teschermo
	dedica l'intero schermo ai testi

dischermo
	crea una zona di testo sullo schermo grafico

catalogo
	corrisponde al comando "dir" del DOS

edita "nome
edtutto_in
	permettono di vedere o correggere un sottoprogramma o
l'intero insieme di sottoprogrammi presente in quel momento nello
spazio di lavoro di DrLogo.
	con F2 si esce senza cambia nulla dall'editor (correttore);
	con F1 si confermano gli eventuali cambiamenti effettuati.

.pa
COPI DELLϠ SCHERMϠ OTTENUT COΠ L'ESECUZIONŠ DE̠ PROGRAMM 
PANORAMA

File:          UDR90402.WR  pe Window Write

PROGRAMM "PANORAMA 

File:          PANORAMA.LOG
              (VERSION PE DR.LOG OLIVETT  PE  SUPERLOGO)
.PA
.PL65
.HEP.N.I. POLO DI UDINE
.HEU.D. 3
.FO<PAG>
{ Programma PANORAMA scritto in linguaggio di progetto }

- - - - - - - - - - - - - - - - - - - - - - - - - - - - 

PROGRAMMA PANORAMA
{ programma principale }
INIZIO
SCOMPARI
PULISCI
SPOSTA -155 -70
PINO 6
SPOSTA -95 -15
CASA 40 40
SPOSTA 5 20
PINO 3
SPOSTA 45 0
CHIESA 50 40
SPOSTA 30 -80
PINO 4
SPOSTA 165 -70
PINO 6
SPOSTA -40 85
STELLA 8
SPOSTA -90 65
STELLA 15
SPOSTA -130 75
STELLA 10
SPOSTA 15 85
STELLA 7
SPOSTA 60 65
STELLA 14	
FINE

- - - - - - - - - - - - - - - - - - - - - - - - - - - - 
.PA
SOTTOPROGRAMMA DENTRO  LARGO  ALTO  { variabili intere }
INIZIO    					 {esempio: DENTRO 20 30}

PENNA_SU
DESTRA 90
AVANTI 1 / 8 *  LARGO
SINISTRA 90 
AVANTI 1 / 2 *  ALTO
PENNA_GIU
RIPETI 5 VOLTE
  INIZIO
		BLOCCO 1 / 12 *  LARGO 3 / 8 *  ALTO 
   	DESTRA 90
		PENNA_SU 
		AVANTI 2 / 12 *  LARGO 
		SINISTRA 90 
		PENNA_GIU
FINE
FINE

- - - - - - - - - - - - - - - - - - - - - - - - - - - - 

SOTTOPROGRAMMA BLOCCO  LARGO  ALTO   { variabili intere }
INIZIO                               {esempio: BLOCCO 10 25}

PENNA_GIU
RIPETI 2 VOLTE
    INIZIO
		AVANTI  ALTO
		DESTRA 90
		AVANTI  LARGO
		DESTRA 90FINE
FINE

- - - - - - - - - - - - - - - - - - - - - - - - - - - - 

SOTTOPROGRAMMA CROCE  AMP   { variabile intera }
INIZIO                      { esempio CROCE 10 }
AVANTI 3 / 5 *  AMP
SINISTRA 90
AVANTI 1 / 5 *  AMP
SINISTRA 180
AVANTI 2 / 5 *  AMP
SINISTRA 180
AVANTI 1 / 5 *  AMP
DESTRA 90                               
AVANTI 1 / 5 *  AMP
DESTRA 180
AVANTI 4 / 5 *  AMP
DESTRA 180
FINE

- - - - - - - - - - - - - - - - - - - - - - - - - - - - 
.PA
SOTTOPROGRAMMA TETTO  BASE  ANGOLO  { variabili intere }
INIZIO                              { esempio TETTO 40 45 }
DESTRA 90 -  ANGOLO
AVANTI  BASE / 2 / COS  ANGOLO
DESTRA 2 *  ANGOLO
AVANTI  BASE / 2 / COS  ANGOLO
DESTRA 180 -  ANGOLO
AVANTI  BASE
DESTRA 90
FINE

- - - - - - - - - - - - - - - - - - - - - - - - - - - - 

SOTTOPROGRAMMA CAMPANILE  LARGO  ALTO  { variabili intere }
INIZIO                                 { esempio CAMPANILE 5 30 }
PENNA_GIU
BLOCCO  LARGO  ALTO 
PENNA_SU
AVANTI 5 / 8 *  ALTO
DESTRA 90
AVANTI 1 / 3 *  LARGO
SINISTRA 90
PENNA_GIU
BLOCCO 1 / 3 *  LARGO 1 / 4 *  ALTO
PENNA_SU
AVANTI 3 / 8 *  ALTO
SINISTRA 90
AVANTI 11 / 24 *  LARGO
DESTRA 90
PENNA_GIU
TETTO 5 / 4 *  LARGO 60
DESTRA 30
AVANTI 5 / 8 *  LARGO / COS 60
SINISTRA 30
CROCE  LARGO
SINISTRA 150
AVANTI 5 / 8 *  LARGO / COS 60
SINISTRA 120
AVANTI 1 / 8 *  LARGO
DESTRA 90
AVANTI 1 / 2 *  ALTO
DESTRA 90
FINE
.PA
- - - - - - - - - - - - - - - - - - - - - - - - - - - - 

SOTTOPROGRAMMA INTERNO  LARGO  ALTO   { variabili intere }
INIZIO                                { esempio INTERNO 10 8 }
SPOSTA 2 / 5 *  LARGO 0
AVANTI 1 / 3 *  ALTO
DESTRA 90
AVANTI 1 / 5 *  LARGO
DESTRA 90
AVANTI 1 / 3 *  ALTO
DESTRA 90
AVANTI 3 / 5 *  LARGO
DESTRA 90
AVANTI 1 / 2 *  ALTO
DESTRA 90
PENNA_SU
AVANTI 1 / 8 *  LARGO
SINISTRA 90
PENNA_GIU
BLOCCO 1 / 4 *  ALTO 1 / 4 *  LARGO
PENNA_SU
DESTRA 90
AVANTI 1 / 2 *  LARGO
SINISTRA 90
PENNA_GIU
BLOCCO 1 / 4 *  ALTO 1 / 4 *  LARGO
FINE

- - - - - - - - - - - - - - - - - - - - - - - - - - - - 

SOTTOPROGRAMMA STELLA  DIM   { variabile intera }
INIZIO                       { esempio STELLA 15 }
RIPETI 9 VOLTE
   INIZIO
		AVANTI  DIM
		 DESTRA 160
	FINE
PENNA_SU
CENTRO 
FINE

.PA
- - - - - - - - - - - - - - - - - - - - - - - - - - - - 

SOTTOPROGRAMMA CHIESA  UNO  DUE   { variabili intere }
INIZIO                            { esempio CHIESA 50 30 }
BLOCCO  UNO  DUE
DENTRO  UNO  DUE
PENNA_SU
DESTRA 180
AVANTI 1 / 2 *  DUE
SINISTRA 90
AVANTI 1 / 24 *  UNO
SINISTRA 90
PENNA_GIU
CAMPANILE 1 / 5 *  UNO 2 *  DUE
AVANTI 13 / 12 *  UNO
DESTRA 135
AVANTI 1 / 12 *  UNO / COS 45
DESTRA 45
AVANTI  UNO
CENTRO
FINE

- - - - - - - - - - - - - - - - - - - - - - - - - - - - 

SOTTOPROGRAMMA CASA  BASE  ALTEZZA  { variabili intere }
INIZIO                              { esempio CASA 40 34 }
BLOCCO  BASE  ALTEZZA
INTERNO  BASE  ALTEZZA
PENNA_SU
SINISTRA 90
AVANTI 5 / 8 *  BASE
DESTRA 90
AVANTI 1 / 2 *  ALTEZZA
PENNA_GIU
TETTO  BASE 40
CENTRO
FINE

- - - - - - - - - - - - - - - - - - - - - - - - - - - - 

.PA
SOTTOPROGRAMMA PINO  PASSO   { variabili intere }
INIZIO                       { esempio PINO 6 }
DESTRA 90
AVANTI  PASSO
SINISTRA 90
AVANTI  PASSO * 4
DESTRA 90
RIPETI 10 VOLTE
	INIZIO
		AVANTI  PASSO
		SINISTRA 1
	FINE
SINISTRA 160
RIPETI 10 VOLTE
  INIZIO
		AVANTI  PASSO + 1
		 DESTRA 2
	FINE
DESTRA 160
RIPETI 9 VOLTE
	INIZIO
		AVANTI  PASSO
		SINISTRA 1
	FINE
SINISTRA 160
RIPETI 9 VOLTE
  INIZIO
		AVANTI  PASSO + 1 
		DESTRA 2
	FINE
DESTRA 160
RIPETI 8 VOLTE
  INIZIO
		AVANTI  PASSO 
		SINISTRA 2
	FINE
SINISTRA 160
RIPETI 12 VOLTE
  INIZIO
		AVANTI  PASSO
		DESTRA 4
	FINE
SINISTRA 140
RIPETI 12 VOLTE
  INIZIO
		DESTRA 4 
		AVANTI  PASSO
	FINE
SINISTRA 160
RIPETI 8 VOLTE
  INIZIO
		SINISTRA 2 
		AVANTI  PASSO
	FINE
DESTRA 160
RIPETI 9 VOLTE
  INIZIO
		DESTRA 2 
		AVANTI  PASSO + 1
	FINE
SINISTRA 160
RIPETI 9 VOLTE
  INIZIO
		SINISTRA 1 
		AVANTI  PASSO
	FINE
DESTRA 160
RIPETI 10 VOLTE
  INIZIO
		DESTRA 2 
		AVANTI  PASSO + 1
	FINE
SINISTRA 160
RIPETI 10 VOLTE
  INIZIO
		SINISTRA 1 
		AVANTI  PASSO
	FINE
DESTRA 88
AVANTI  PASSO * 4
SINISTRA 90
AVANTI  PASSO
SINISTRA 90
CENTRO
FINE

- - - - - - - - - - - - - - - - - - - - - - - - - - - - 

SOTTOPROGRAMMA SPOSTA  ASCISSA  ORDINATA  { variabili intere }
INIZIO                                   { esempio SPOSTA 30 120 }
PENNA_SU
AVANTI  ORDINATA
DESTRA 90
AVANTI  ASCISSA
SINISTRA 90
PENNA_GIU
FINE

- - - - - - - - - - - - - - - - - - - - - - - - - - - - 
.PA
SCHEDA Sk. Inf.1  U.D. 2 CILE (1986-87)
.pa
.HEP.N.I POLO DI UDINE
.HEU.D. 3
	Il comando DrLogo "CAPOSTIPITI" permette di individuare,
nello spazio di lavoro, quella o quelle procedure che non sono
sottoprogrammi.  Nel caso di PANORAMA, nel dare l'ordine in
ambiente DrLogo, otterremo il seguente risultato:

?CAPOSTIPITI
PER PANORAMA

	Una utilissima primitiva, nel fare l'analisi gerarchica di un
programma, e' "FIGLIE", che va applicata al nome di qualsiasi
procedura interessi.
	Appricandola al capostipite "PANORAMA otterremo un risultato
che - completato con altri simboli grafici appare come il
seguente:
?FIGLIE "PANORAMA

PANORAMA
 
  SPOSTA :ASCISSA :ORDINAT
 
  PINO :PASSO
     
      CENTRO
 
  CASA :BASE :ALTEZZA
     
      BLOCCO :LARGO :ALTO
     
      INTERNO :LARGO :ALTO
         
          SPOSTA :ASCISSA :ORDINAT
          BLOCCO :LARGO :ALTO
     
      TETTO :BASE :ANGOLO
     
      CENTRO
 
  CHIESA :UNO :DUE
     
      BLOCCO :LARGO :ALTO
     
      DENTRO :LARGO :ALTO
         
          BLOCCO :LARGO :ALTO
     
      CAMPANILE :LARGO :ALTO
         
          BLOCCO :LARGO :ALTO
          TETTO :BASE :ANGOLO
          CROCE :AMP
     
      CENTRO
 
  STELLA :DIM
.pa
.HEP.N.I. POLO DI UDINE
.HEU.D. 3
Scomposizion d u problem d geometri analitic second un 
metodologia Top-Down
S vogli trovar l'intersezion tr un circonferenz e un 
retta s conoscan centr  raggi dell circonferenz  du 
punti della retta.
Un possibil soluzion de problem potrebb esser - scritt 
sotto forma algoritmica - la seguente:

     PER INTERSEZIONE
          CIRCONFERENZA {si trovi l'equaz. della circonferenza}
          RETTA         {si trovi l'equazione della retta}
          SISTEMA       {si risolva il sistema tra le equazioni}
     FINE

Tal programm principal puo esser scompost vi vi i 
sottoprogrammi:

     PER CIRCONFERENZA
          RAGGIO
          CENTRO
          DISTANZA
     FINE

     PER RETTA
          PUNTI
          RETTA_PER_DUE_PUNTI
     FINE

Fin a arrivar all provedur minimali corrispondent all 
abilita' che si considerano acquisite.

PER SISTEMA         {sistema tra due equazioni}
FINE

PER RETTA_PER_DUE_OUNTI {equazione della retta}
FINE

PER PUNTI           {acquisizione delle coordinate}
FINE

PER DISTANZA        {formula della distanza tra due punti}
FINE

PER CENTRO          {acquisizione del centro della circonferenza}
FINE

PER RAGGIO          {acquisizione del raggio della circonferenza}
FINE
.pa
.HEP.N.I. POLO DI UDINE
.HEU.D. 3
.HESK 07
L struttur gerarchic tr l procedur e evidenziat dall'us 
delle due primitive DrLogo:
          CAPOSTIPITI
          FIGLIE "...

?RECUPERA "TOPDOWN

?CAPOSTIPITI
PER INTERSEZIONE

?FIGLIE "INTERSEZIONE

INTERSEZIONE
     CIRCONFERENZA
          RAGGIO
          CENTRO
          DISTAMNZA
     RETTA
          PUNTI
          RETTA_PER_DUE_PUNTI
     SISTEMA
.PA
.HEP.N.I. POLO DI UDINE
.HEU.D. 3
.HEApp 1
.FO#
Elenco delle primitive del Dr. Logo (LOGO DIGITAL RESEARCH), nella
traduzione fattane a cura della Olivetti.

A               ACASO           ACCHIAPPA 
AIUTO           AMB             APRI 
ARCAPERTI       ARCTAN          ARRO
AS              ASCIFRE         ASCII 
ASCOL           ASCURSORE       ASDIR 
ASDISCO         ASORIGINE       ASPENNA 
ASPETTA         ASPROP          ASPUNTO 
ASRIGHE         ASRIS           ASSCHIA 
ASSFONDO        ASSO            ASTAVOLOZZA 
ASZOOM          ATTORNO         AVANTI 
CANCEAIUTO      CANCEARC        CANCENOMI_IN 
CANCEPENNA      CANCEPROC       CANCEPROC_IN 
CANCEPROP       CANCETUTTO_IN   CANCEVAR 
CANCE_DIS       CAPOSTIPITI     CAR 
CAT             CATALOGO        CAT_DIS 
CHIAMA          CHIUDI          CHIUDITUTTO 
CIFRE           CONSERVA        CONSERVA_DIS 
CONTA           CONTINUA        CON_PROP 
COPIADEF        COPRI           COS 
COSA            COSA?           CP 
CURSORE         D               DACHELEGGI 
DATISCHERMO     DATITARTA       DEC 
DEF?            DEFINISCI       DESTRA 
DIR             DISCHERMO       DISCO
DOVE            DOVEPENNAL 
EDARC           EDITA           ED 
EDNOMI_IN       EDPROC_IN       EDTUTTO_IN 
ELE             ELE?            ERRORE 
ESEGUI          ESP             FIGLIE 
FINELEGGI?      FINESTRA        FINTO 
FRASE           GIU             GRADI 
GRASCHERMO      I               INDIETRO 
INPRI           INT             INULT 
INVERPENNA      IP              LANCIA 
LEGGICAR        LC              LEGGILISTA 
LEGGISTRINGA    LEGGI_DA        LIBERA 
LISTA           LISTA?          LISTAPROP 
LISTA_TITOLI    LL              LN 
LOCALE          LOG10           LS 
MADRI           MAIUSCOLO       MENPRI 
MENULT          MINUSCOLO       MISCHIA 
MISURA          MOSTARTA        MOSTRA 
MOUSE           MURO            MT 
NASTARTA        NT              NODI 
NON             NONOSSERVARE    NONSTAMPARE
NONTRACCIARE    NTRA            NUMELE 
NUMERO?         O               OPPURE 
ORDINE          OSSERVA         PAC 
PACTUTTO        PAROLA          PAROLA? 
PAUSA           PENNAL          PENNAL? 
PEZZO           PIGRECO         PRI 
PRIMITIVA?      PRODOTTO        PROP 
PS              PULISCI         PULISCISCHERMO 
PULISCITESTO    PULSANTE?       PUNTO 
PT              QUI             QUOZIENTE 
RADIANTI        RADQ            RECUPERA 
RECUPERA_DIS    RESTO           RIACASO 
RIEMPI          RINOMINAARC     RIORDINA 
RIPETI          RIPORTA         S 
SC 
SCI             SCOPRI          SCRIVI 
SCRIVI_SU       SE              SEF 
SEN             SEV             SE_FALSO 
SE_VERO         SINISTRA        SLISTEPROP 
SOMMA           SPAC            SPROC 
SPROC_IN        ST
STAMPA          STAMPASEMPRE    STITOLI 
STOP            STUTTO_IN 
SU              SUCHESCRIVI 
SUONA           SVAR_IN         TAN 
TANA 
TARTASCRIVI     TASTO?          TAVOLOZZA 
TESCHERMO       TESTO           TRACCIA 
UGUALE?         ULT             VAI 
VATANA          VAX             VAXY 
VAY             VERIFICA        VERSO 
VUOTO?          XCOR            YCOR  
*               +               - 
/               <               <= 
<>              =               =< 
=>              >               >= 
>< 




